//******************************************************************************
//* 					             Rec_Cmd.C
//* The function is reading the RS-232 command from the Hyper Terminal (VT100)
//* 
//*     Press "1" for setting the Maximum Temperature with 2 digital
//*   	Press "2" for setting the Minimum Temperature with 2 digital
//*
//******************************************************************************

#include "Main.h"

extern near unsigned char Rec_Data;
extern near union
{
	unsigned char Flag;	
	struct {
			unsigned Key_Flag:1;
    		unsigned Timer1_Flag:1;
    		unsigned Pause_Flag:1;
			unsigned Buzzer_On_Flag:1;
			unsigned Buzzer_Fast_Flag:1;
			unsigned Buzzer_Mid_Flag:1;
			unsigned Buzzer_Slow_Flag:1;
			unsigned Shutdown_Flag:1;
    		};		
} Flagbits;

#pragma udata access My_RAM_3
near int T2_Max_Data;
near int T2_Min_Data;
near int T2_Setting;
near unsigned char T2_Hi;
near unsigned char T2_Mid;
near unsigned char T2_Low;

near union
{
int Word;
unsigned char Byte[2];
}T2;

#pragma udata


void Rec_Cmd_Check(void)
{
	if (Rec_Data!=0x00)
	{
		switch(Rec_Data)
		{
			case ('1'):
			{
				Modify_T2_Max( );
			} break;
			
			case ('2'):
			{
				Modify_T2_Min( );
			} break;
		}
		Rec_Data=0;
				
	}		
 
}


void Modify_T2_Max(void)
{	
	Rec_Data=0;
	VT100_Cursor_Position(20,34);
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	VT100_Cursor_Position(20,34);
	T2_Max_Data = Get_3_Digital( ); 
	
	T2.Word=T2_Max_Data;
	EE_Write(0x00,T2.Byte[0]);
	EE_Write(0x01,T2.Byte[1]);

}

void Modify_T2_Min(void) 
{
	Rec_Data=0;
	VT100_Cursor_Position(21,34);
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	VT100_Cursor_Position(21,34);
	T2_Min_Data = Get_3_Digital( ); 
	T2.Word=T2_Min_Data;
	EE_Write(0x02,T2.Byte[0]);
	EE_Write(0x03,T2.Byte[1]);
}

int Get_3_Digital(void)
{		
	do
	{		
		while(Rec_Data==0x00);	// Wait for Hi-Nibble to be received
    	T2_Hi = Rec_Data;
    	Rec_Data=0x00;

    } while (T2_Hi < '0' || T2_Hi > '9');
    WriteUSART(T2_Hi);

 	do
	{		
		while(Rec_Data==0x00);	// Wait for Mid-Nibble to be received
    	T2_Mid  = Rec_Data;
    	Rec_Data=0x00;
    	
    } while (T2_Mid < '0' || T2_Mid > '9');	
    WriteUSART(T2_Mid);
	while (BusyUSART( ));
    WriteUSART('.');
		   	
   	do
	{		
		while(Rec_Data==0x00);	// Wait for Low_Nibble to be received
    	T2_Low = Rec_Data;
    	Rec_Data=0x00;
    	
    } while (T2_Low < '0' || T2_Low > '9');
    WriteUSART(T2_Low);

//**************************************************************
//* @@@@   mߥ|@10i16i
//* T2_Hi , T2_Mid , T2_Low OsVT100TASCIIƥئr
//* int T2_Setting ̫ഫG
//*
//* NUASCIIƥئrഫBCDXAন۹16i
//* NU16iȪvȬۥ[o@16i
//**************************************************************

	T2_Setting = (int) (T2_Hi & 0x0F);		// Convert BCD code to HEX code
	T2_Setting = T2_Setting * 100;
	T2_Mid = (T2_Mid & 0x0F) * 0x0A;
	T2_Low = (T2_Low & 0x0F);
    T2_Setting = T2_Setting+ (int) T2_Mid;
	T2_Setting = T2_Setting+ (int) T2_Low;

	Print_Byte('C');
	return	T2_Setting;
}
